<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css" integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">
  <link rel="stylesheet" href="index.css">
  <title>Memory test</title>
  
</head>

<body>
  
  <div class="container h-100">
    <div id="main"class="row h-100 justify-content-center align-items-center">
        
    </div>  
  </div>




  <script type="application/javascript" src="https://unpkg.com/react@16.0.0/umd/react.production.min.js"></script>
  <script type="application/javascript" src="https://unpkg.com/react-dom@16.0.0/umd/react-dom.production.min.js"></script>
  <script type="application/javascript" src="https://unpkg.com/babel-standalone@6.26.0/babel.js"></script>
 
<script src="index.js"></script>
<script type="text/babel">

// Create a function to wrap up your component

//--------------UI OCMPONENTS-----------------------------------------
const ResetIcon=({handleClick})=>(<span className="float-right" onClick={handleClick}><i className="fas fa-power-off"></i></span>)
const Message=({text})=>( <h1 className="container">{text}</h1>)
const InputObject=({value,handleChange})=>( <input type="text" value={value} onChange={handleChange} className="form-control"/>)

const LevelOption=({value,handleChange,isChecked})=>( <input className="form-check-input" type="radio" value={value} checked={isChecked} onChange={handleChange}/> )

const ButtonAll=({text,handleClick})=>( <button className="btn btn-info m-3" onClick={handleClick}>{text}</button>)

const Clock=({countdown,time,start})=>(<div id="countdown">
  <div id="countdown-number">{countdown}</div>
  <svg>
    <circle r="18" cx="20" cy="20" style={start?{
    animation: `countdown ${time}s linear infinite forwards`}:{}} ></circle>
  </svg>
</div>)
const LittleMessage=({text,style})=>(<p class={`text-${style}`}>{text}</p>)
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//---------------------------------COMPONENTE UI 1ra------------------------------

class FirstStep extends React.Component{
componentDidMount(){
  this.props.fetchObjects()
}
  render(){
    const {levels,handleChange,handleClick}=this.props
    return(
      <div>
      <Message text="Dificultad en minutos"/>
      <LittleMessage text="Es el tiempo que tendras para memorizar 20 objetos" style="info"/>
      
        {levels.map(level=>(<div className="form-check form-check-inline" key={level.value}><LevelOption value={level.value} isChecked={level.isChecked} handleChange={handleChange}/>{`${level.value} min`}</div>))}
      <br/>
      <ButtonAll text="Comenzar" handleClick={()=>handleClick({first:true})}/>
      </div>

    )
  }
}

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//---------------------------------COMPONENTE UI 2da------------------------------
class SecondStep extends React.Component{
  constructor(props){
    super(props)
    this.state={
      countdown:0,
      index:-1,
      kill:0,
      start:false
    }
  }
componentDidMount(){
//Guardo la variable para matar el intervalo luego
var kill=setInterval(function() {
  //inicio a count y a i
  var count
  var i=this.state.index
  if(this.state.countdown <= 1){
    count=this.props.time
    i++
  }else{
    count=this.state.countdown-1
  }
  //Evaluo si ya llegaron al final
  if(i==this.props.objects.length){
    clearInterval(this.state.kill)//mato el intervalo
    this.props.completeSecond({second:true})//Anuncio que completamos
  }else{
    this.setState({countdown:count,index:i,start:true})
  }
  //Lo bindeo
}.bind(this), 1000);
//Seteo el mata intervalos
this.setState({kill})
}

render(){
  const {objects,time}=this.props
  const {kill,start,countdown,index}=this.state
  var object=objects[index]
  
    return (<div>
    <Message text={object}/>
    <Clock countdown={countdown} start={start} time={time}/>
    </div>)
  
}
}

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//---------------------------------COMPONENTE UI 3ra------------------------------

class ThirdStep extends React.Component{
  constructor(props){
    super(props)
    this.state={inputValue:"",
                submits:0}
    this.handleChange=this.handleChange.bind(this)
    this.handleClick=this.handleClick.bind(this)
    this.giveUp=this.giveUp.bind(this)
  }
  handleChange(e){
    var value=e.target.value
    this.setState({inputValue:value})
  }

  handleClick(){
    this.props.setResponse(this.state.inputValue)
    if((this.state.submits+1)>=this.props.objects.length){
      this.props.completeStep({third:true})
    }else
      {this.setState(state=>({inputValue:"",submits:state.submits+1}))}    
  }
  giveUp(){
      var array=[]
      for(let i=0;i<(this.props.objects.length-this.state.submits);i++){
        array[i]="Nada"
      }
    this.props.setResponse(array)
    this.props.completeStep({third:true})
  }
  render(){
    const {inputValue,submits}=this.state
    return (
    <div onKeyDown={(e)=>{if(e.keyCode==13){
      this.handleClick()
    }}}><InputObject value={inputValue} handleChange={this.handleChange}/>
      <ButtonAll text={`Respuesta N°:${submits+1}`} handleClick={this.handleClick} />
      <ButtonAll text="Me rindo" handleClick={this.giveUp} />
      </div>  
    )
  }
}
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//---------------------------------COMPONENTE UI 4ta------------------------------
class FourthStep extends React.Component{
  constructor(props){
    super(props)
    this.state={errors:[]}
    this.reset=this.reset.bind(this)
  }
  componentDidMount(){
    const {objects,answer} =this.props
    
    var errors=[]
    objects.map((object,index)=>{
     
      if(object.toString().toLowerCase()!==answer[index].toString().toLowerCase()){
        errors.push([object,answer[index],index])
      }
    })
    
    this.setState({errors})
  }
  reset(){
    this.props.handleClick({first:false,second:false,third:false})
  }
  render(){
    if(this.state.errors.length){
      return (
        <div>
        <Message text="Hay errores:"/>
        {
          this.state.errors.map((errores)=>(
            <LittleMessage text={`${errores[2]+1}) Se esperaba "${errores[0]}" y coloco "${errores[1]}"`}
            style="danger"/>))
        }
        <ButtonAll text="¡Volver a Jugar!" handleClick={this.reset}/>
      </div>
      )
    }
    return (
      <div><Message text="¡Haz Ganado!"/>
        <LittleMessage text="Continua al proximo desafio" style="success"/>
        <ButtonAll text="¡Volver a Jugar!" handleClick={this.reset}/>
      </div>)
  }
}
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
class MemoryOne extends React.Component{
  constructor(props){
    super(props)
    this.state={levels:fastLevels,
                objects:[],
                answer:[]}  
    this.changeCurrentLevel=this.changeCurrentLevel.bind(this)
    this.setResponse=this.setResponse.bind(this)
    this.fetchObjects=this.fetchObjects.bind(this)
  }
  changeCurrentLevel(e){
    var value=e.target.value
      this.setState(state=>({levels:state.levels.map(level=>{
        
          return level.value==value?{value:level.value,isChecked:true}:{value:level.value,isChecked:false}
        
      })}))
  }
 fetchObjects(){
   this.setState({objects:randomObjects()})
 }

  setResponse(value){
    this.setState(state=>({answer:state.answer.concat(value)}))
    
  }

  render(){
    console.log(this.state.answer)
    const {levels,objects,answer}=this.state
    const {first,second,third,completeStep}=this.props
    const currentLevel=levels.filter(l=>l.isChecked)[0].value
    if(!first){
      return(
      <FirstStep levels={levels} fetchObjects={this.fetchObjects} handleClick={completeStep} handleChange={this.changeCurrentLevel}/>)
    }
    else if (!second){
      return(
      <SecondStep completeSecond={completeStep} objects={objects} time={parseInt(currentLevel*60/objects.length)}/>)
    }
    else if (!third){
      return(
      <ThirdStep completeStep={completeStep} objects={objects} setResponse={this.setResponse}/>)
    }
    return(
      <FourthStep objects={objects} answer={answer} handleClick={completeStep}/>

    )
  }
}

//-------------------------------------------------------------------------------
//---------------------------------COMPONENTE PADRE------------------------------


class App extends React.Component{
  constructor(props){
    super(props)
    this.state={
                first:false,
                second:false,
                third:false}

    this.completeStep=this.completeStep.bind(this)
  }
  
  completeStep(step){
    this.setState(step)
  }

  render(){
    const {first,second,third}=this.state
    return(<div class="col-11 col-sm-6 text-center shadow-lg p-3 mb-5 rounded">
      <ResetIcon handleClick={()=>this.completeStep({first:false,second:false,third:false})}/>
      <MemoryOne first={first} second={second} third={third} completeStep={this.completeStep}/>
    </div>
    )
    
  }
}
// Use the ReactDOM.render to show your component on the browser
    ReactDOM.render(
      <App />,
      document.getElementById('main')
    )
</script>

</body>

</html>